/* Standard-Funktionen für SPS-Steuerung
    Autor: Dr.-Ing. Dirk Drescher
 */

function Wechseln_Uebertragen(Formular,Name)
{
  var SPSVariablenname = Name.replace(/:/g, '"');
  var Wert = document.forms[Formular].elements[SPSVariablenname].value;
  if (Wert == 0) {Wert = 1;}
  else {Wert = 0;}
  document.forms[Formular].elements[SPSVariablenname].value = Wert;
  Schieberegler_Send(SPSVariablenname, Wert);
}

var Senden_aktiv = false;
var xmlhttp = null;
var XML_Variablen = new Array();
var XML_Typen = new Array();
var XML_Indexes = new Array();
var XML_Werte = new Array();
var XML_Schalter = new Array();
var XML_DB = new Array();
var Dokumente = new Array();

function Init_Regler()
{ // initialisiert die Schieberegler Tasten und muss im body-Tag aufgerufen werden, onLoad="Init_Regler"
  var Tasten = document.getElementsByClassName('touch');
  for (var i=0; i<Tasten.length; i++)
  {
    var TastenID = Tasten[i].getAttribute('name');
    var TastenInfo = TastenID.split('~');
    if (TastenInfo[0] == 'WU')
    {
	Tasten[i].onclick = Taste_Click;
	Tasten[i].ontouchstart = Taste_Touch;
    }
  }
  loadXML();
}

function Wechseln_Uebertragen(Formular,Name)
{
  var SPSVariablenname = Name.replace(/:/g, '"');
  var Wert = document.forms[Formular].elements[SPSVariablenname].value;
  if (Wert == 0) {Wert = 1;}
  else {Wert = 0;}
  document.forms[Formular].elements[SPSVariablenname].value = Wert;
  Schieberegler_Send(SPSVariablenname, Wert);
}

function Taste_Click(Ereignis)
{ // Event-Handler für drücken
  var TastenID = Ereignis.target.getAttribute('name');
  var TastenInfo = TastenID.split('~');
  if (TastenInfo[0] == 'WU') Wechseln_Uebertragen(TastenInfo[1],TastenInfo[2]);
}

function Taste_Touch(Ereignis)
{ // Event-Handler für drücken
  var Touches = Ereignis.targetTouches;
  for (var i=0; i<Touches.length; i++)
  { // Jedes Touchereignis prüfen
    var TastenID = Ereignis.targetTouches[i].target.getAttribute('name');
    if (TastenID)
    {
      var TastenInfo = TastenID.split('~');
      if (TastenInfo[0] == 'WU')
      {
	Wechseln_Uebertragen(TastenInfo[1],TastenInfo[2]);
	break;
      }
    }
  }
  Ereignis.preventDefault();
}

function Schieberegler_Send(SPSVariablenname, Reglerwert)
{ // Reglerwert senden
  var Dateipfad = document.location.href;
  var Dateiname = Dateipfad.substring(Dateipfad.lastIndexOf("/")+1);
  var XMLName = Dateiname.substring(0,Dateiname.lastIndexOf(".")) + '.xml';

  if (window.XMLHttpRequest)
  {// code for IE7+, Firefox, Chrome, Opera, Safari
    xmlhttp=new XMLHttpRequest();
  }
  // Eigentlicher Aufruf
  Senden_aktiv = true;
  xmlhttp.open("POST",XMLName,true);
  xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
  xmlhttp.onreadystatechange=OnStateChange;
  xmlhttp.send(SPSVariablenname+'='+Reglerwert);
}

function loadXML()
{
  // Detail-HTML ermitteln
  var Dateipfad = document.location.href;
  var Dateiname = Dateipfad.substring(Dateipfad.lastIndexOf("/")+1);
  var XMLName = Dateiname.substring(0,Dateiname.lastIndexOf(".")) + '.xml';

  if (window.XMLHttpRequest)
  {// code for IE7+, Firefox, Chrome, Opera, Safari
    xmlhttp=new XMLHttpRequest();
  }
  else
  {// code for IE6, IE5
    xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
  }

  document.getElementById("xml_status").src = 'xml_nicht_geladen.png';
  xmlhttp.onreadystatechange=OnStateChange;
  xmlhttp.open("GET",XMLName,true);
  xmlhttp.send();
}

function OnStateChange()
{
  if (xmlhttp.readyState==4 && xmlhttp.status==200)
  {
    Senden_aktiv = false;
    var xmlDoc=xmlhttp.responseXML;
    var VariableID;
    // alle Frames inklusive Hauptfenster registrieren
    Dokumente[0] = top.document;
    Dokumente[1] = top.frames["Details"].document;

    // alle enthaltenen Elemente auswerten
    for (var i=0; i<xmlDoc.getElementsByTagName('set').length; i++)
    { // jedes Raum element verarbeiten
      var Raumknoten = xmlDoc.getElementsByTagName('set')[i];

      // Jetzt Sammler lesen
      var Sammler = Raumknoten.getElementsByTagName('sammler')[0].firstChild.nodeValue;
      var Sammlerwerte = Sammler.split("~");

      // jede Variable lesen
      for (var j=0; j<Raumknoten.getElementsByTagName('variable').length; j++)
      { // jede Raumvariable verarbeiten, die einen direkten Wert hat
	var Raumvariablename = Raumknoten.getElementsByTagName('variable')[j].getAttribute("name");
	var Raumvariabletyp = Raumknoten.getElementsByTagName('variable')[j].getAttribute("type");
	var Raumvariableindex = Raumknoten.getElementsByTagName('variable')[j].getAttribute("index");
	var Raumvariableschalter = Raumknoten.getElementsByTagName('variable')[j].getAttribute("invers");
	var Raumvariablenwert = Raumknoten.getElementsByTagName('variable')[j].firstChild.nodeValue;
	var Raumname = Raumknoten.getElementsByTagName('variable')[j].getAttribute("db");
	XML_DB[j] = Raumname;
	XML_Variablen[j] = Raumvariablename;
	XML_Typen[j] = Raumvariabletyp;
	XML_Indexes[j] = Raumvariableindex;
	XML_Werte[j] = Raumvariablenwert;
	XML_Schalter[j] = Raumvariableschalter;
      }
      // Jetzt die Werte verarbeiten
      for (var j=0; j < XML_Variablen.length; j++)
      {
	// Wert im Detailfenster und Hauptfenster aktualisieren
	if (XML_Typen[j] == 'wert')
	{ // Zahlenwert
	  VariableID = XML_DB[j] + "_" + XML_Variablen[j];
	  // Jeden Frame durchsuchen
	  for (var f=0; f < Dokumente.length; f++)
	  {
	    var Hauptframe = Dokumente[f];
	    //alert("Variable: "+VariableID);
	    if (Hauptframe.getElementById(VariableID))
	    { // Formular existiert -> Werte setzen
	      if (XML_Indexes[j] == "yes")
	      { // es ist ein Index -> Wert auslesen
		var XML_Idx = XML_Werte[j];
		Raumvariablenwert = Sammlerwerte[XML_Idx].replace(/^\s+|\s+$/g,'');
	      }
	      else {Raumvariablenwert = XML_Werte[j];}
	      if (XML_Schalter[j] == 1) {Hauptframe.getElementById(VariableID).innerHTML = Raumvariablenwert;}
	      else {Hauptframe.getElementById(VariableID).value = Raumvariablenwert;}
	    }
	  }
	}
	else if (XML_Typen[j] == 'bitgrafik')
	{ // Umschaltgrafik
	  VariableID = XML_DB[j] + "_" + XML_Variablen[j];
	  // Jeden Frame durchsuchen
	  for (var f=0; f < Dokumente.length; f++)
	  {
	    var Hauptframe = Dokumente[f];
	    //alert("Variable: "+VariableID);
	    if (XML_Indexes[j] == "yes")
	    { // es ist ein Index -> Wert auslesen
	      var XML_Idx = XML_Werte[j];
	      Raumvariablenwert = Sammlerwerte[XML_Idx].replace(/^\s+|\s+$/g,'');
	    }
	    else {Raumvariablenwert = XML_Werte[j];}
	    if (Hauptframe.getElementById(VariableID))
	    { // Formular existiert -> Werte setzen
	      Hauptframe.getElementById(VariableID).value = Raumvariablenwert;
	    }
	    // Grafik setzen
	    //alert("ID: Grafik_"+VariableID+"; Wert="+XML_Variablen[j]+'_'+Raumvariablenwert+'.png');
	    if (Hauptframe.getElementById("Grafik_"+VariableID))
	    {
		Hauptframe.getElementById("Grafik_"+VariableID).src = XML_Variablen[j]+'_'+Raumvariablenwert+'.png';
		// bei Warntasten noch Farbe setzen
		// Elern-DIV ermitteln
		var Eltern_Div = Hauptframe.getElementById("Grafik_"+VariableID).parentNode;
		if (Eltern_Div.classList.contains('mark_0'))
		{ // Class color_0
		  if (Raumvariablenwert == 0)
		  {
		    if (!Eltern_Div.classList.contains('color_0')) {Eltern_Div.classList.add('color_0');}
		  }
		  else {Eltern_Div.classList.remove('color_0');}
		}
	    }
	  }
	}
	else
	{ // Typ unbekannt -> Fehlermeldung
	  alert("unbekannter Typ '" + XML_Typen[j] + "' in Raum " + XML_DB[j] + ", Variable " + XML_Variablen[j]);
	}
      }
    }
    // Status geladen anzeigen
    document.getElementById("xml_status").src = 'xml_geladen.png';
  }
}